#ifndef _normalizer_h
#define _normalizer_h

#ifdef __GNUG__
#pragma interface
#endif

class normalizer {
  double r;			// Product of normalizations this far
  double max;			// When to normalize
  double invmax;		// When to normalize
 public:
  normalizer();
  void normalize(double &x);
  void normalize(double &x1, double &x2);
  void normalize(double &x1, double &x2, double &x3);
  void normalize(double &x1, double &x2, double &x3, double &x4);
  void normalize(double &x1, double &x2, double &x3, double &x4, double &x5);

  void setlimit(double lim);
  double previous_normalizations();
};

#endif
