/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse zzparse
#define yylex   zzlex
#define yyerror zzerror
#define yylval  zzlval
#define yychar  zzchar
#define yydebug zzdebug
#define yynerrs zznerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NUM = 258,
     VAR = 259,
     FNCT = 260,
     STRING = 261,
     START = 262,
     QUIT = 263,
     HELP = 264,
     DISPLAY = 265,
     SET = 266,
     SWITCH = 267,
     SAVE_STATE = 268,
     RESTORE_STATE = 269,
     ON = 270,
     OFF = 271,
     PLOT = 272,
     AXIS = 273,
     LINEPLOT = 274,
     LINLIN = 275,
     LINLOG = 276,
     LOGLIN = 277,
     LOGLOG = 278,
     GNANS_TRUE = 279,
     GNANS_FALSE = 280,
     FUNCTIONS = 281,
     INTERNALS = 282,
     RESOURCES = 283,
     PARAMETERS = 284,
     RANDOMS = 285,
     STATES = 286,
     TIMES = 287,
     SYSTEM = 288,
     VARIABLES = 289,
     STORE = 290,
     UNSTORE = 291,
     CONTINUE = 292,
     CONTINUE_INIT = 293,
     ALGORITHM = 294,
     FORMAT = 295,
     PERCENTE = 296,
     SLASHE = 297,
     TIMESE = 298,
     MINUSE = 299,
     PLUSE = 300,
     OR = 301,
     AND = 302,
     NE = 303,
     EQ = 304,
     LE = 305,
     GE = 306,
     GG = 307,
     LL = 308,
     MINUSMINUS = 309,
     PLUSPLUS = 310,
     UPLUS = 311,
     UMINUS = 312
   };
#endif
#define NUM 258
#define VAR 259
#define FNCT 260
#define STRING 261
#define START 262
#define QUIT 263
#define HELP 264
#define DISPLAY 265
#define SET 266
#define SWITCH 267
#define SAVE_STATE 268
#define RESTORE_STATE 269
#define ON 270
#define OFF 271
#define PLOT 272
#define AXIS 273
#define LINEPLOT 274
#define LINLIN 275
#define LINLOG 276
#define LOGLIN 277
#define LOGLOG 278
#define GNANS_TRUE 279
#define GNANS_FALSE 280
#define FUNCTIONS 281
#define INTERNALS 282
#define RESOURCES 283
#define PARAMETERS 284
#define RANDOMS 285
#define STATES 286
#define TIMES 287
#define SYSTEM 288
#define VARIABLES 289
#define STORE 290
#define UNSTORE 291
#define CONTINUE 292
#define CONTINUE_INIT 293
#define ALGORITHM 294
#define FORMAT 295
#define PERCENTE 296
#define SLASHE 297
#define TIMESE 298
#define MINUSE 299
#define PLUSE 300
#define OR 301
#define AND 302
#define NE 303
#define EQ 304
#define LE 305
#define GE 306
#define GG 307
#define LL 308
#define MINUSMINUS 309
#define PLUSPLUS 310
#define UPLUS 311
#define UMINUS 312




/* Copy the first part of user declarations.  */
#line 1 "cmdparse.yy"

/*
 Copyright (C) 1992 Bengt Martensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

/* $Id: cmdparse.y,v 1.10 1994/08/24 09:58:29 bengt Exp $ */

/*
 * This file defines the grammar for the script language.
 */

/*
 * yyparse should return:
 * 0 if everything has been successfully completed,
 * 1 on nonrecoverable error,
 * 2 if interrupted by the clock
 */

#define YYDEBUG 1

#ifdef __GNUC__
//#include <builtin.h>		/* pow(long, long) */
#endif

#include <math.h>
#include <stdlib.h>
#include "externals.h"
#include "utillib.h"
typedef char *String;           // ??????????????? FIXME
#include "Plotter.h"

extern "C" char *tilde_expand(char *); /* From Gnu readline */
#define PROMPT do_prompt(); \
                if (abort_script) return 1;\
		if (has_been_alarmed) return 2;
#define SCRIPT_LOG if (do_logging) va_log_event

#define HELPTEXT \
  "Gnans is documented in the Texinfo format, which allows the same file\n"\
  "to generate both an online, hypertext help system, and a version which\n"\
  "can be printed with TeX.  Please consult this file, either reading it\n"\
  "online with, e.g. Gnu Emacs or another info reader, or read the\n"\
  "printed documentation.\n"
/*
 * Assign a value to a variable, provided that the variable is not readonly.
 * Otherwise barf.
 */
static double
maybe_assign(symrec *variable, double value)
{
  if (! variable->readonly) {
    *variable = value;
    SCRIPT_LOG("%s = %g", variable->name, value);
  } else
    printf("\a`%s' is readonly!\n", variable->name);
  return value;
}

static void
assign_ans(double x)
{
  *(getsym("ans")) = x;
}

/*
 * Some junk to get rid of warnings on labels not used.
 */
#ifdef __GNUC__
#ifdef YYBISON
#define SHUT_UP_GCC_WARNINGS \
  if (0) \
    goto yyerrlab1; \
  else \
    goto yybackup;
#else
#define SHUT_UP_GCC_WARNINGS \
  if (0) \
    goto yyerrlab; \
  else \
    goto yynewstate;
#define free(p) c_free((generic_ptr) p)
#endif
#else
#define SHUT_UP_GCC_WARNINGS
#endif



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 105 "cmdparse.yy"
typedef union YYSTYPE {
  int action;			/* For returning gnans commands */
  char *text;			/* For returning strings */
  double val;			/* For returning numbers */
  symrec *tptr;			/* For returning symbol-table pointers */
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 308 "cmdparse.cc"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 320 "cmdparse.cc"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   453

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  78
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  12
/* YYNRULES -- Number of rules. */
#define YYNRULES  86
/* YYNRULES -- Number of states. */
#define YYNSTATES  156

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   312

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      73,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    66,     2,     2,     2,    65,    52,     2,
      75,    77,    63,    62,    76,    61,     2,    64,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    48,    74,
      55,    41,    56,    47,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    72,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    51,     2,    67,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    42,    43,    44,    45,
      46,    49,    50,    53,    54,    57,    58,    59,    60,    68,
      69,    70,    71
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    11,    14,    17,    20,
      23,    26,    28,    30,    32,    34,    36,    39,    42,    47,
      52,    56,    60,    63,    66,    73,    77,    78,    81,    85,
      89,    91,    93,    95,    97,    99,   101,   105,   106,   109,
     110,   112,   114,   116,   118,   120,   122,   124,   126,   128,
     130,   134,   138,   142,   146,   150,   154,   159,   163,   167,
     171,   175,   179,   182,   185,   188,   191,   194,   197,   200,
     203,   207,   211,   215,   219,   223,   227,   231,   235,   239,
     243,   247,   251,   255,   259,   265,   270
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      79,     0,    -1,    -1,    79,    80,    -1,    73,    -1,    74,
      -1,    89,    74,    -1,    89,    73,    -1,    81,    73,    -1,
      81,    74,    -1,     1,    73,    -1,     7,    -1,    37,    -1,
      38,    -1,     9,    -1,     8,    -1,    33,     6,    -1,    10,
      88,    -1,    11,    39,    41,     6,    -1,    11,    40,    41,
       6,    -1,    12,     6,    15,    -1,    12,     6,    16,    -1,
      35,     4,    -1,    36,     4,    -1,    14,    75,     4,    76,
      89,    77,    -1,    17,    82,    86,    -1,    -1,    83,    82,
      -1,    18,    41,    85,    -1,    19,    41,    84,    -1,    24,
      -1,    25,    -1,    20,    -1,    21,    -1,    22,    -1,    23,
      -1,     4,     4,    87,    -1,    -1,     4,    87,    -1,    -1,
      31,    -1,    34,    -1,    29,    -1,    26,    -1,    32,    -1,
      27,    -1,    28,    -1,    30,    -1,     3,    -1,     4,    -1,
       4,    41,    89,    -1,     4,    46,    89,    -1,     4,    45,
      89,    -1,     4,    44,    89,    -1,     4,    43,    89,    -1,
       4,    42,    89,    -1,     5,    75,    89,    77,    -1,    89,
      62,    89,    -1,    89,    61,    89,    -1,    89,    63,    89,
      -1,    89,    64,    89,    -1,    89,    65,    89,    -1,    69,
       4,    -1,    68,     4,    -1,     4,    69,    -1,     4,    68,
      -1,    61,    89,    -1,    62,    89,    -1,    66,    89,    -1,
      67,    89,    -1,    89,    72,    89,    -1,    75,    89,    77,
      -1,    89,    60,    89,    -1,    89,    59,    89,    -1,    89,
      54,    89,    -1,    89,    53,    89,    -1,    89,    57,    89,
      -1,    89,    58,    89,    -1,    89,    55,    89,    -1,    89,
      56,    89,    -1,    89,    52,    89,    -1,    89,    51,    89,
      -1,    89,    50,    89,    -1,    89,    49,    89,    -1,    89,
      47,    89,    48,    89,    -1,    13,    75,     4,    77,    -1,
      13,    75,     4,    76,    89,    77,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   174,   174,   175,   179,   180,   181,   182,   187,   188,
     189,   192,   193,   194,   195,   196,   198,   211,   213,   215,
     217,   219,   221,   222,   223,   225,   258,   259,   263,   264,
     268,   269,   272,   273,   274,   275,   279,   292,   294,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   316,   317,
     318,   319,   320,   321,   323,   324,   328,   329,   330,   331,
     332,   333,   334,   336,   338,   340,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   362,   364
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NUM", "VAR", "FNCT", "STRING", "START", 
  "QUIT", "HELP", "DISPLAY", "SET", "SWITCH", "SAVE_STATE", 
  "RESTORE_STATE", "ON", "OFF", "PLOT", "AXIS", "LINEPLOT", "LINLIN", 
  "LINLOG", "LOGLIN", "LOGLOG", "GNANS_TRUE", "GNANS_FALSE", "FUNCTIONS", 
  "INTERNALS", "RESOURCES", "PARAMETERS", "RANDOMS", "STATES", "TIMES", 
  "SYSTEM", "VARIABLES", "STORE", "UNSTORE", "CONTINUE", "CONTINUE_INIT", 
  "ALGORITHM", "FORMAT", "'='", "PERCENTE", "SLASHE", "TIMESE", "MINUSE", 
  "PLUSE", "'?'", "':'", "OR", "AND", "'|'", "'&'", "NE", "EQ", "'<'", 
  "'>'", "LE", "GE", "GG", "LL", "'-'", "'+'", "'*'", "'/'", "'%'", "'!'", 
  "'~'", "MINUSMINUS", "PLUSPLUS", "UPLUS", "UMINUS", "'^'", "'\\n'", 
  "';'", "'('", "','", "')'", "$accept", "input", "stmt", "cmd", 
  "plot_options", "plot_option", "boolean", "axis_type", "plot_vars", 
  "pe_plot_vars", "display_unit", "exp", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    61,   296,   297,   298,   299,   300,    63,    58,   301,
     302,   124,    38,   303,   304,    60,    62,   305,   306,   307,
     308,    45,    43,    42,    47,    37,    33,   126,   309,   310,
     311,   312,    94,    10,    59,    40,    44,    41
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    78,    79,    79,    80,    80,    80,    80,    80,    80,
      80,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    82,    82,    83,    83,
      84,    84,    85,    85,    85,    85,    86,    87,    87,    88,
      88,    88,    88,    88,    88,    88,    88,    88,    89,    89,
      89,    89,    89,    89,    89,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    89,    89
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     1,     1,     2,     2,     2,     2,
       2,     1,     1,     1,     1,     1,     2,     2,     4,     4,
       3,     3,     2,     2,     6,     3,     0,     2,     3,     3,
       1,     1,     1,     1,     1,     1,     3,     0,     2,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     4,     3,     3,     3,
       3,     3,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     5,     4,     6
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     1,     0,    48,    49,     0,    11,    15,    14,
      39,     0,     0,     0,     0,    26,     0,     0,     0,    12,
      13,     0,     0,     0,     0,     0,     0,     4,     5,     0,
       3,     0,     0,    10,     0,     0,     0,     0,     0,     0,
      65,    64,     0,    43,    45,    46,    42,    47,    40,    44,
      41,    17,     0,     0,     0,     0,     0,     0,     0,     0,
      26,    16,    22,    23,    66,    67,    68,    69,    63,    62,
       0,     8,     9,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     7,     6,    50,    55,    54,    53,    52,    51,
       0,     0,     0,    20,    21,     0,     0,     0,     0,     0,
      25,    27,    71,     0,    83,    82,    81,    80,    75,    74,
      78,    79,    76,    77,    73,    72,    58,    57,    59,    60,
      61,    70,    56,    18,    19,     0,    85,     0,    32,    33,
      34,    35,    28,    30,    31,    29,    37,     0,     0,     0,
      37,    36,    84,    86,    24,    38
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,    30,    31,    59,    60,   145,   142,   110,   151,
      51,    32
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -65
static const short yypact[] =
{
     -65,    71,   -65,   -64,   -65,   -19,   -55,   -65,   -65,   -65,
     419,     0,    37,   -30,   -24,    23,    42,    69,    95,   -65,
     -65,    25,    25,    25,    25,    97,    98,   -65,   -65,    25,
     -65,   -27,   216,   -65,    25,    25,    25,    25,    25,    25,
     -65,   -65,    25,   -65,   -65,   -65,   -65,   -65,   -65,   -65,
     -65,   -65,    36,    62,    74,   101,   106,    70,    72,   108,
      23,   -65,   -65,   -65,    43,    43,    43,    43,   -65,   -65,
     100,   -65,   -65,    25,    25,    25,    25,    25,    25,    25,
      25,    25,    25,    25,    25,    25,    25,    25,    25,    25,
      25,    25,   -65,   -65,   268,   268,   268,   268,   268,   268,
     129,   116,   117,   -65,   -65,    19,    48,   -16,    73,   121,
     -65,   -65,   -65,   244,   291,   313,   334,   354,   372,   372,
     -28,   -28,   -28,   -28,    56,    56,   -53,   -53,    43,    43,
      43,    43,   -65,   -65,   -65,    25,   -65,    25,   -65,   -65,
     -65,   -65,   -65,   -65,   -65,   -65,   123,    25,   158,   187,
     123,   -65,   268,   -65,   -65,   -65
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -65,   -65,   -65,   -65,    75,   -65,   -65,   -65,   -65,   -20,
     -65,   -21
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      64,    65,    66,    67,   138,   139,   140,   141,    70,    33,
      88,    89,    90,    94,    95,    96,    97,    98,    99,    91,
      42,   100,    34,    35,    36,    37,    38,    39,     4,     5,
       6,    84,    85,    86,    87,    88,    89,    90,    13,    52,
      53,    57,    58,    54,    91,    55,    71,    72,    61,    40,
      41,    56,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,     2,     3,    62,     4,     5,     6,   101,     7,     8,
       9,    10,    11,    12,    13,    14,    21,    22,    15,   103,
     104,    23,    24,    25,    26,   135,   136,   143,   144,    63,
      29,    68,    69,   102,    16,   105,    17,    18,    19,    20,
     106,   107,   109,   108,   148,    91,   149,    86,    87,    88,
      89,    90,   133,   134,   137,   146,   152,   150,    91,     0,
     155,     0,    21,    22,     0,   111,     0,    23,    24,    25,
      26,     0,     0,     0,    27,    28,    29,    73,     0,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,     0,     0,     0,     0,
       0,     0,    91,     0,     0,     0,    73,   112,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,     0,     0,     0,     0,     0,
       0,    91,     0,     0,     0,    73,   132,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,     0,     0,     0,     0,     0,     0,
      91,     0,     0,     0,    73,   153,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,     0,     0,     0,     0,     0,     0,    91,
       0,     0,     0,    73,   154,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,     0,     0,     0,     0,     0,     0,    91,    92,
      93,    73,   147,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
       0,     0,     0,     0,     0,    73,    91,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,     0,     0,     0,     0,     0,     0,
      91,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,     0,     0,     0,
       0,     0,     0,    91,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,     0,
       0,     0,     0,     0,     0,    91,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
       0,     0,     0,     0,     0,     0,    91,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
       0,     0,     0,     0,     0,     0,    91,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,     0,     0,
       0,     0,     0,     0,    91,    43,    44,    45,    46,    47,
      48,    49,     0,    50
};

static const short yycheck[] =
{
      21,    22,    23,    24,    20,    21,    22,    23,    29,    73,
      63,    64,    65,    34,    35,    36,    37,    38,    39,    72,
      75,    42,    41,    42,    43,    44,    45,    46,     3,     4,
       5,    59,    60,    61,    62,    63,    64,    65,    13,    39,
      40,    18,    19,     6,    72,    75,    73,    74,     6,    68,
      69,    75,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,     0,     1,     4,     3,     4,     5,    41,     7,     8,
       9,    10,    11,    12,    13,    14,    61,    62,    17,    15,
      16,    66,    67,    68,    69,    76,    77,    24,    25,     4,
      75,     4,     4,    41,    33,     4,    35,    36,    37,    38,
       4,    41,     4,    41,   135,    72,   137,    61,    62,    63,
      64,    65,     6,     6,    76,     4,   147,     4,    72,    -1,
     150,    -1,    61,    62,    -1,    60,    -1,    66,    67,    68,
      69,    -1,    -1,    -1,    73,    74,    75,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    -1,    -1,    -1,    -1,
      -1,    -1,    72,    -1,    -1,    -1,    47,    77,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    -1,    -1,    -1,    -1,    -1,
      -1,    72,    -1,    -1,    -1,    47,    77,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      72,    -1,    -1,    -1,    47,    77,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,    72,
      -1,    -1,    -1,    47,    77,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    -1,    -1,    -1,    72,    73,
      74,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    -1,    -1,    47,    72,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      72,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    -1,    -1,    -1,
      -1,    -1,    -1,    72,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    -1,    -1,    -1,    72,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    72,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    72,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    72,    26,    27,    28,    29,    30,
      31,    32,    -1,    34
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    79,     0,     1,     3,     4,     5,     7,     8,     9,
      10,    11,    12,    13,    14,    17,    33,    35,    36,    37,
      38,    61,    62,    66,    67,    68,    69,    73,    74,    75,
      80,    81,    89,    73,    41,    42,    43,    44,    45,    46,
      68,    69,    75,    26,    27,    28,    29,    30,    31,    32,
      34,    88,    39,    40,     6,    75,    75,    18,    19,    82,
      83,     6,     4,     4,    89,    89,    89,    89,     4,     4,
      89,    73,    74,    47,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    72,    73,    74,    89,    89,    89,    89,    89,    89,
      89,    41,    41,    15,    16,     4,     4,    41,    41,     4,
      86,    82,    77,    89,    89,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    89,    89,    89,    89,    89,
      89,    89,    77,     6,     6,    76,    77,    76,    20,    21,
      22,    23,    85,    24,    25,    84,     4,    48,    89,    89,
       4,    87,    89,    77,    77,    87
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 179 "cmdparse.yy"
    { PROMPT; }
    break;

  case 5:
#line 180 "cmdparse.yy"
    {}
    break;

  case 6:
#line 181 "cmdparse.yy"
    { assign_ans(yyvsp[-1].val); }
    break;

  case 7:
#line 182 "cmdparse.yy"
    {
                          printf(floating_point_format.c_str(), yyvsp[-1].val);
                          assign_ans(yyvsp[-1].val);
                          PROMPT;
                        }
    break;

  case 8:
#line 187 "cmdparse.yy"
    {}
    break;

  case 9:
#line 188 "cmdparse.yy"
    {}
    break;

  case 10:
#line 189 "cmdparse.yy"
    { yyerrok; PROMPT; }
    break;

  case 11:
#line 192 "cmdparse.yy"
    { integrate(init_all); PROMPT; }
    break;

  case 12:
#line 193 "cmdparse.yy"
    { integrate(init_none); PROMPT; }
    break;

  case 13:
#line 194 "cmdparse.yy"
    { integrate(init_states); PROMPT; }
    break;

  case 14:
#line 195 "cmdparse.yy"
    { printf(HELPTEXT); PROMPT; }
    break;

  case 15:
#line 196 "cmdparse.yy"
    { SCRIPT_LOG("Quit"); die("", 0);
			  SHUT_UP_GCC_WARNINGS; }
    break;

  case 16:
#line 198 "cmdparse.yy"
    { 
#ifdef DYNAMIC_LOADING
  char *name = tilde_expand(yyvsp[0].text);
  setup_system_dynamic(String(name));
  free(name);
  delete [] yyvsp[0].text;
  update_symbol_table();
#else
  gnans_error(non_fatal,
	      "Sorry, this version of Gnans doesn't support dynamic loading");
  delete [] yyvsp[0].text;
#endif
			  PROMPT; }
    break;

  case 17:
#line 212 "cmdparse.yy"
    { Display_vars(yyvsp[0].action); PROMPT; }
    break;

  case 18:
#line 214 "cmdparse.yy"
    { select_algorithm(yyvsp[0].text); delete [] yyvsp[0].text; PROMPT; }
    break;

  case 19:
#line 216 "cmdparse.yy"
    { select_format(yyvsp[0].text); delete [] yyvsp[0].text; PROMPT; }
    break;

  case 20:
#line 218 "cmdparse.yy"
    { toggle_switch(yyvsp[-1].text, true); delete [] yyvsp[-1].text; PROMPT; }
    break;

  case 21:
#line 220 "cmdparse.yy"
    { toggle_switch(yyvsp[-1].text, false); delete [] yyvsp[-1].text; PROMPT; }
    break;

  case 22:
#line 221 "cmdparse.yy"
    { store(yyvsp[0].tptr->name, true); PROMPT; }
    break;

  case 23:
#line 222 "cmdparse.yy"
    { store(yyvsp[0].tptr->name, false); PROMPT; }
    break;

  case 24:
#line 224 "cmdparse.yy"
    { restore_state(yyvsp[-3].tptr->name, (unsigned int) yyvsp[-1].val); PROMPT; }
    break;

  case 25:
#line 226 "cmdparse.yy"
    { if (toplevel) {
                             Plotter *p = new Plotter(toplevel, yyvsp[0].text);
                             if (yyvsp[-1].action % 1000 == LINLOG)
                                p->linlog_select(Plotter::LinLog);
                             if (yyvsp[-1].action % 1000 == LOGLIN)
                                p->linlog_select(Plotter::LogLin);
                             if (yyvsp[-1].action % 1000 == LOGLOG)
                                p->linlog_select(Plotter::LogLog);
                             //if (($2 % 10000)/1000) {
                                //p->print_postscript();
                             //}
                             //if ($2/10000)
			     //   delete p;
                             if (yyvsp[-1].action/1000 == GNANS_TRUE) {
                                p->point_p=false;
                                p->plot_type(true, false);
                             }
                             if (yyvsp[-1].action/1000 == GNANS_FALSE) {
                                p->point_p=true;
                                p->plot_type(true, false);
                             }


                          } else
                             gnans_error(non_fatal, 
                                         "X not initialized, cannot plot");
                          delete [] yyvsp[0].text;
                          PROMPT;
}
    break;

  case 26:
#line 258 "cmdparse.yy"
    { yyval.action = 0; }
    break;

  case 27:
#line 259 "cmdparse.yy"
    { yyval.action = yyvsp[-1].action + yyvsp[0].action;}
    break;

  case 28:
#line 263 "cmdparse.yy"
    {yyval.action = yyvsp[0].action;}
    break;

  case 29:
#line 264 "cmdparse.yy"
    {yyval.action = 1000*yyvsp[0].action;}
    break;

  case 30:
#line 268 "cmdparse.yy"
    { yyval.action = GNANS_TRUE; }
    break;

  case 31:
#line 269 "cmdparse.yy"
    { yyval.action = GNANS_FALSE; }
    break;

  case 32:
#line 272 "cmdparse.yy"
    { yyval.action = LINLIN; }
    break;

  case 33:
#line 273 "cmdparse.yy"
    { yyval.action = LINLOG; }
    break;

  case 34:
#line 274 "cmdparse.yy"
    { yyval.action = LOGLIN; }
    break;

  case 35:
#line 275 "cmdparse.yy"
    { yyval.action = LOGLOG; }
    break;

  case 36:
#line 279 "cmdparse.yy"
    { yyval.text = new char[MAXSTRINGSIZE];
                                 strcpy(yyval.text, yyvsp[-2].tptr->name);
                                 strcat(yyval.text, ",");
	                         strcat(yyval.text, yyvsp[-1].tptr->name);
				 if (strlen(yyvsp[0].text)) {
				    strcat(yyval.text, ",");
				    strcat(yyval.text, yyvsp[0].text);
                                 }
                                 delete [] yyvsp[0].text;
}
    break;

  case 37:
#line 292 "cmdparse.yy"
    { yyval.text = new char[MAXSTRINGSIZE];
                             yyval.text[0] = '\0'; }
    break;

  case 38:
#line 294 "cmdparse.yy"
    { yyval.text = new char[MAXSTRINGSIZE];
                             strcpy(yyval.text, yyvsp[-1].tptr->name);
			     if (strlen(yyvsp[0].text)) {
				strcat(yyval.text, ",");
				strcat(yyval.text, yyvsp[0].text);
                             }
                             delete [] yyvsp[0].text;
}
    break;

  case 39:
#line 305 "cmdparse.yy"
    { yyval.action = 0; }
    break;

  case 40:
#line 306 "cmdparse.yy"
    { yyval.action = STATES; }
    break;

  case 41:
#line 307 "cmdparse.yy"
    { yyval.action = VARIABLES; }
    break;

  case 42:
#line 308 "cmdparse.yy"
    { yyval.action = PARAMETERS; }
    break;

  case 43:
#line 309 "cmdparse.yy"
    { yyval.action = FUNCTIONS; }
    break;

  case 44:
#line 310 "cmdparse.yy"
    { yyval.action = TIMES; }
    break;

  case 45:
#line 311 "cmdparse.yy"
    { yyval.action = INTERNALS; }
    break;

  case 46:
#line 312 "cmdparse.yy"
    { yyval.action = RESOURCES; }
    break;

  case 47:
#line 313 "cmdparse.yy"
    { yyval.action = RANDOMS; }
    break;

  case 48:
#line 316 "cmdparse.yy"
    { yyval.val = yyvsp[0].val; }
    break;

  case 49:
#line 317 "cmdparse.yy"
    { yyval.val = *yyvsp[0].tptr; }
    break;

  case 50:
#line 318 "cmdparse.yy"
    { yyval.val = maybe_assign(yyvsp[-2].tptr, yyvsp[0].val); }
    break;

  case 51:
#line 319 "cmdparse.yy"
    { yyval.val = maybe_assign(yyvsp[-2].tptr, double(*yyvsp[-2].tptr) + yyvsp[0].val); }
    break;

  case 52:
#line 320 "cmdparse.yy"
    { yyval.val = maybe_assign(yyvsp[-2].tptr, double(*yyvsp[-2].tptr) - yyvsp[0].val); }
    break;

  case 53:
#line 321 "cmdparse.yy"
    { yyval.val = maybe_assign(yyvsp[-2].tptr, double(*yyvsp[-2].tptr) * yyvsp[0].val);
			   }
    break;

  case 54:
#line 323 "cmdparse.yy"
    { yyval.val = maybe_assign(yyvsp[-2].tptr, double(*yyvsp[-2].tptr) / yyvsp[0].val); }
    break;

  case 55:
#line 324 "cmdparse.yy"
    { yyval.val = maybe_assign(yyvsp[-2].tptr,
					       /*(double)*/
					       ((int) *yyvsp[-2].tptr %
						(int) yyvsp[0].val)); }
    break;

  case 56:
#line 328 "cmdparse.yy"
    { yyval.val = (*(yyvsp[-3].tptr->fnctptr))(yyvsp[-1].val); }
    break;

  case 57:
#line 329 "cmdparse.yy"
    { yyval.val = yyvsp[-2].val + yyvsp[0].val; }
    break;

  case 58:
#line 330 "cmdparse.yy"
    { yyval.val = yyvsp[-2].val - yyvsp[0].val; }
    break;

  case 59:
#line 331 "cmdparse.yy"
    { yyval.val = yyvsp[-2].val * yyvsp[0].val; }
    break;

  case 60:
#line 332 "cmdparse.yy"
    { yyval.val = yyvsp[-2].val / yyvsp[0].val; }
    break;

  case 61:
#line 333 "cmdparse.yy"
    { yyval.val = (int) yyvsp[-2].val % (int) yyvsp[0].val; }
    break;

  case 62:
#line 334 "cmdparse.yy"
    { yyval.val = *yyvsp[0].tptr;
			  maybe_assign(yyvsp[0].tptr, double(*yyvsp[0].tptr) + 1.0); }
    break;

  case 63:
#line 336 "cmdparse.yy"
    { yyval.val = *yyvsp[0].tptr;
			   maybe_assign(yyvsp[0].tptr, double(*yyvsp[0].tptr) - 1.0); }
    break;

  case 64:
#line 338 "cmdparse.yy"
    { yyval.val = double(*yyvsp[-1].tptr) + 1.0;
			       maybe_assign(yyvsp[-1].tptr, double(*yyvsp[-1].tptr) + 1.0); }
    break;

  case 65:
#line 340 "cmdparse.yy"
    { yyval.val = double(*yyvsp[-1].tptr) - 1.0;
			       maybe_assign(yyvsp[-1].tptr, double(*yyvsp[-1].tptr) - 1.0); }
    break;

  case 66:
#line 342 "cmdparse.yy"
    { yyval.val = -yyvsp[0].val; }
    break;

  case 67:
#line 343 "cmdparse.yy"
    { yyval.val = +yyvsp[0].val; }
    break;

  case 68:
#line 344 "cmdparse.yy"
    { yyval.val = ! (int) yyvsp[0].val; }
    break;

  case 69:
#line 345 "cmdparse.yy"
    { yyval.val = ~ (int) yyvsp[0].val; }
    break;

  case 70:
#line 346 "cmdparse.yy"
    { yyval.val = pow(yyvsp[-2].val, yyvsp[0].val); }
    break;

  case 71:
#line 347 "cmdparse.yy"
    { yyval.val = yyvsp[-1].val; }
    break;

  case 72:
#line 348 "cmdparse.yy"
    { yyval.val = (int) yyvsp[-2].val << (int) yyvsp[0].val; }
    break;

  case 73:
#line 349 "cmdparse.yy"
    { yyval.val = (int) yyvsp[-2].val >> (int) yyvsp[0].val; }
    break;

  case 74:
#line 350 "cmdparse.yy"
    { yyval.val = yyvsp[-2].val == yyvsp[0].val; }
    break;

  case 75:
#line 351 "cmdparse.yy"
    { yyval.val = yyvsp[-2].val != yyvsp[0].val; }
    break;

  case 76:
#line 352 "cmdparse.yy"
    { yyval.val = yyvsp[-2].val <= yyvsp[0].val; }
    break;

  case 77:
#line 353 "cmdparse.yy"
    { yyval.val = yyvsp[-2].val >= yyvsp[0].val; }
    break;

  case 78:
#line 354 "cmdparse.yy"
    { yyval.val = yyvsp[-2].val < yyvsp[0].val; }
    break;

  case 79:
#line 355 "cmdparse.yy"
    { yyval.val = yyvsp[-2].val > yyvsp[0].val; }
    break;

  case 80:
#line 356 "cmdparse.yy"
    { yyval.val = (int) yyvsp[-2].val & (int) yyvsp[0].val; }
    break;

  case 81:
#line 357 "cmdparse.yy"
    { yyval.val = (int) yyvsp[-2].val | (int) yyvsp[0].val; }
    break;

  case 82:
#line 358 "cmdparse.yy"
    { yyval.val = (int) yyvsp[-2].val && (int) yyvsp[0].val; }
    break;

  case 83:
#line 359 "cmdparse.yy"
    { yyval.val = (int) yyvsp[-2].val || (int) yyvsp[0].val; }
    break;

  case 84:
#line 361 "cmdparse.yy"
    { yyval.val = ((int) yyvsp[-4].val ? yyvsp[-2].val : yyvsp[0].val); }
    break;

  case 85:
#line 363 "cmdparse.yy"
    { yyval.val = save_state(yyvsp[-1].tptr->name); }
    break;

  case 86:
#line 365 "cmdparse.yy"
    { yyval.val = save_state_numbered(yyvsp[-3].tptr->name,
						   (unsigned int) yyvsp[-1].val); }
    break;


    }

/* Line 991 of yacc.c.  */
#line 1886 "cmdparse.cc"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__) \
    && !defined __cplusplus
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 368 "cmdparse.yy"


