#ifndef _delay_h
#define _delay_h

#ifdef __GNUG__
#pragma interface
#endif

class delay_line {
  double initial;
  double *times;
  double *values;
  unsigned int size;
  unsigned int index;
  unsigned int last_read_index;
  double value(double delaytime);
 public:
  delay_line();
  double initialize(double init);
  double operator=(double init) 		 { return initialize(init); }
  double value(double /*now*/, double delaytime) { return value(delaytime); }
  double update(double value);
  void close();
  ~delay_line();
};

#endif
