// -*- c++ -*-

/* $Id: utillib.h,v 1.5 1994/08/19 18:14:03 bengt Exp $ */

#ifndef _utillib_h
#ifdef __GNUG__
#pragma interface
#endif
#define _utillib_h

#ifdef String
#undef String
#endif
#include <string>

extern void zap_suffix(char *filename);
extern /*const*/ char *basename(const char *fullname);
extern char *getdate();
extern double gnans_NaN();
extern std::string number_String(double x);
extern std::string number_String(int x);
extern std::string number_String(long int x);
extern std::string number_String(unsigned int x);
extern std::string gethostname_as_string();

inline int
max(int x, int y)
{
  return x > y ? x : y;
}

inline double
max(double x, double y)
{
  return x > y ? x : y;
}

#endif // ! _utillib_h
